/*
 * The evaluation function parameters
 *
 * This parameter set (NE6) was used at the US-Open
 *
 */

int WSbonus=0,WLbonus=0,BSbonus= -0,BLbonus= -0;

decl_param (BadBishop0, -251);
decl_param (Backward0, 64);
decl_param (Backward1, 135);
decl_param (BishopBlock0, 256);
decl_param (BishopDefense0, 0);
decl_param (BishopDefense1, 32);
decl_param (BishopPlacement0, 35);
decl_param (BishopPlacement1, 6);
decl_param (BishopPlacement2, 0);
decl_param (BishopValue, 6528);
decl_param (BlockedKingShelter0, -27);
decl_param (BlockedKingShelter1, 21);
decl_param (DoubleClosed0, 465);
decl_param (DoubleClosed1, -193);
decl_param (DoubleIsoClosed0, 668);
decl_param (DoubleIsoClosed1, -237);
decl_param (DoubleIsoOpen0, 690);
decl_param (DoubleIsoOpen1, -47);
decl_param (DoubleOpen0, 421);
decl_param (DoubleOpen1, -59);
decl_param (KingCentrality0, 61);
decl_param (KingCentrality1, -46);
decl_param (KingCentrality2, -52);
decl_param (KingShelter0, -67);
decl_param (KingShelter1, 415);
decl_param (KnightCentrality0, 38);
decl_param (KnightCentrality1, 26);
decl_param (KnightCentrality2, -16);
decl_param (KnightDefense0, -1);
decl_param (KnightDefense1, 41);
decl_param (KnightInCorner0, 0);
decl_param (KnightInCorner1, 1536);
decl_param (KnightTropism0, 9);
decl_param (KnightTropism1, 56);
decl_param (KnightValue, 6274);
decl_param (NoBishopPawn0, 0);
decl_param (NoBishopPawn1, 71);
decl_param (NoKnightPawn0, 0);
decl_param (NoKnightPawn1, 358);
decl_param (NoRookPawn0, -114);
decl_param (NoRookPawn1, 179);
decl_param (OneBishop0, -9);
decl_param (OneBishop1, 41);

#ifdef OLD_PPA
decl_param (PPAdvance0, 39);
decl_param (PPAdvance1, -16);
decl_param (PPAdvance2, -8);
decl_param (PPCentral0, -7);
decl_param (PPCentral1, 13);
#else
decl_3tab(PPAdvance, 1553, 4, 6, 72, 3, 3, 3) = {
    {
        {5, 4, 3, 2},
        {12, 11, 9, 8},
        {25, 23, 22, 21},
        {50, 49, 48, 47},
        {127, 126, 125, 124},
        {256, 255, 254, 253}
    },
    {
        {5, 4, 3, 2},
        {12, 11, 9, 8},
        {24, 23, 22, 21},
        {50, 49, 48, 47},
        {127, 125, 124, 123},
        {254, 253, 252, 251}
    },
    {
        {5, 4, 3, 2},
        {12, 11, 9, 8},
        {24, 23, 22, 21},
        {50, 49, 47, 46},
        {126, 125, 124, 123},
        {253, 252, 250, 249}
    },
    {
        {5, 4, 3, 2},
        {12, 10, 9, 8},
        {24, 23, 22, 21},
        {49, 48, 47, 46},
        {125, 124, 123, 122},
        {251, 250, 249, 248}
    },
    {
        {5, 4, 3, 2},
        {11, 10, 9, 8},
        {24, 23, 22, 21},
        {49, 48, 47, 46},
        {124, 123, 122, 121},
        {249, 248, 247, 246}
    },
    {
        {5, 4, 3, 2},
        {11, 10, 9, 8},
        {24, 23, 22, 21},
        {49, 48, 47, 46},
        {123, 122, 121, 120},
        {247, 246, 245, 244}
    },
    {
        {5, 4, 3, 2},
        {11, 10, 9, 9},
        {24, 23, 22, 21},
        {48, 47, 46, 46},
        {122, 121, 120, 119},
        {246, 245, 244, 243}
    },
    {
        {5, 4, 3, 2},
        {11, 10, 9, 9},
        {24, 23, 22, 21},
        {48, 47, 46, 45},
        {121, 120, 120, 119},
        {244, 243, 242, 241}
    },
    {
        {5, 4, 3, 3},
        {11, 10, 10, 9},
        {23, 23, 22, 21},
        {48, 47, 46, 45},
        {120, 120, 119, 118},
        {242, 241, 240, 239}
    },
    {
        {5, 4, 3, 3},
        {11, 10, 10, 9},
        {23, 22, 22, 21},
        {47, 46, 46, 45},
        {120, 119, 118, 117},
        {240, 239, 238, 237}
    },
    {
        {5, 4, 4, 3},
        {11, 10, 10, 9},
        {23, 22, 21, 21},
        {47, 46, 45, 45},
        {119, 118, 117, 116},
        {238, 237, 236, 236}
    },
    {
        {5, 4, 4, 3},
        {11, 10, 10, 9},
        {23, 22, 21, 21},
        {47, 46, 45, 44},
        {118, 117, 116, 115},
        {236, 235, 234, 234}
    },
    {
        {5, 4, 4, 3},
        {11, 10, 10, 9},
        {23, 22, 21, 21},
        {46, 45, 45, 44},
        {117, 116, 115, 114},
        {234, 233, 233, 232}
    },
    {
        {5, 4, 4, 3},
        {11, 10, 10, 9},
        {23, 22, 21, 20},
        {46, 45, 44, 44},
        {116, 115, 114, 114},
        {232, 231, 231, 230}
    },
    {
        {5, 4, 4, 3},
        {11, 10, 10, 9},
        {22, 22, 21, 20},
        {45, 45, 44, 43},
        {115, 114, 113, 113},
        {230, 229, 229, 228}
    },
    {
        {5, 4, 4, 3},
        {11, 10, 10, 9},
        {22, 22, 21, 20},
        {45, 44, 44, 43},
        {114, 113, 112, 112},
        {228, 227, 227, 226}
    },
    {
        {5, 4, 4, 3},
        {11, 10, 10, 9},
        {22, 21, 21, 20},
        {45, 44, 43, 43},
        {113, 112, 111, 111},
        {226, 225, 225, 224}
    },
    {
        {5, 4, 4, 3},
        {11, 10, 10, 9},
        {22, 21, 21, 20},
        {44, 44, 43, 43},
        {112, 111, 110, 110},
        {224, 223, 223, 222}
    },
    {
        {5, 4, 4, 3},
        {11, 10, 10, 9},
        {22, 21, 21, 20},
        {44, 43, 43, 42},
        {111, 110, 109, 109},
        {222, 221, 220, 220}
    },
    {
        {5, 5, 4, 4},
        {10, 10, 10, 9},
        {21, 21, 20, 20},
        {43, 43, 42, 42},
        {109, 109, 108, 108},
        {219, 219, 218, 218}
    },
    {
        {5, 5, 4, 4},
        {10, 10, 9, 9},
        {21, 21, 20, 20},
        {43, 43, 42, 42},
        {108, 108, 107, 107},
        {217, 217, 216, 216}
    },
    {
        {5, 5, 4, 4},
        {10, 10, 9, 9},
        {21, 21, 20, 20},
        {43, 42, 42, 41},
        {107, 107, 106, 106},
        {215, 215, 214, 214}
    },
    {
        {5, 5, 4, 4},
        {10, 10, 9, 9},
        {21, 21, 20, 20},
        {42, 42, 41, 41},
        {106, 106, 105, 105},
        {213, 212, 212, 212}
    },
    {
        {5, 5, 4, 4},
        {10, 10, 9, 9},
        {21, 20, 20, 20},
        {42, 41, 41, 41},
        {105, 105, 104, 104},
        {210, 210, 210, 209}
    },
    {
        {5, 5, 4, 4},
        {10, 10, 9, 9},
        {21, 20, 20, 20},
        {41, 41, 41, 40},
        {104, 104, 103, 103},
        {208, 208, 207, 207}
    },
    {
        {5, 5, 4, 4},
        {10, 10, 9, 9},
        {20, 20, 20, 19},
        {41, 41, 40, 40},
        {103, 102, 102, 102},
        {206, 205, 205, 205}
    },
    {
        {5, 5, 4, 4},
        {10, 10, 9, 9},
        {20, 20, 20, 19},
        {40, 40, 40, 40},
        {102, 101, 101, 101},
        {203, 203, 203, 203}
    },
    {
        {5, 5, 4, 4},
        {10, 10, 9, 9},
        {20, 20, 19, 19},
        {40, 40, 40, 39},
        {100, 100, 100, 100},
        {201, 201, 201, 200}
    },
    {
        {5, 5, 4, 4},
        {10, 10, 9, 9},
        {20, 20, 19, 19},
        {40, 39, 39, 39},
        {99, 99, 99, 99},
        {199, 198, 198, 198}
    },
    {
        {5, 5, 4, 4},
        {10, 10, 9, 9},
        {19, 19, 19, 19},
        {39, 39, 39, 39},
        {98, 98, 98, 98},
        {196, 196, 196, 196}
    },
    {
        {5, 5, 4, 4},
        {10, 9, 9, 9},
        {19, 19, 19, 19},
        {39, 39, 38, 38},
        {97, 97, 97, 96},
        {194, 194, 193, 193}
    },
    {
        {5, 5, 5, 4},
        {9, 9, 9, 9},
        {19, 19, 19, 19},
        {38, 38, 38, 38},
        {96, 95, 95, 95},
        {191, 191, 191, 191}
    },
    {
        {5, 5, 5, 5},
        {9, 9, 9, 9},
        {19, 19, 19, 19},
        {38, 38, 38, 38},
        {94, 94, 94, 94},
        {189, 189, 189, 188}
    },
    {
        {5, 5, 5, 5},
        {9, 9, 9, 9},
        {19, 19, 19, 19},
        {37, 37, 37, 37},
        {93, 93, 93, 93},
        {186, 186, 186, 186}
    },
    {
        {5, 5, 5, 5},
        {9, 9, 9, 9},
        {18, 18, 18, 18},
        {37, 37, 37, 37},
        {92, 92, 92, 92},
        {183, 183, 184, 184}
    },
    {
        {5, 5, 5, 5},
        {9, 9, 9, 9},
        {18, 18, 18, 18},
        {36, 36, 36, 36},
        {90, 91, 91, 91},
        {181, 181, 181, 181}
    },
    {
        {5, 5, 5, 5},
        {9, 9, 9, 9},
        {18, 18, 18, 18},
        {36, 36, 36, 36},
        {89, 89, 89, 89},
        {178, 178, 178, 178}
    },
    {
        {5, 5, 5, 5},
        {9, 9, 9, 9},
        {18, 18, 18, 18},
        {35, 35, 35, 36},
        {88, 88, 88, 88},
        {176, 176, 176, 176}
    },
    {
        {4, 5, 5, 5},
        {9, 9, 9, 9},
        {17, 18, 18, 18},
        {35, 35, 35, 35},
        {86, 87, 87, 87},
        {173, 173, 173, 173}
    },
    {
        {4, 5, 5, 5},
        {9, 9, 9, 9},
        {17, 17, 18, 18},
        {34, 34, 35, 35},
        {85, 85, 86, 86},
        {170, 170, 171, 171}
    },
    {
        {4, 5, 5, 5},
        {9, 9, 9, 9},
        {17, 17, 17, 18},
        {34, 34, 34, 34},
        {84, 84, 84, 84},
        {167, 168, 168, 168}
    },
    {
        {4, 5, 5, 5},
        {8, 9, 9, 9},
        {17, 17, 17, 17},
        {33, 33, 34, 34},
        {82, 83, 83, 83},
        {165, 165, 165, 165}
    },
    {
        {4, 5, 5, 5},
        {8, 9, 9, 9},
        {16, 17, 17, 17},
        {33, 33, 33, 33},
        {81, 81, 82, 82},
        {162, 162, 162, 163}
    },
    {
        {4, 5, 5, 5},
        {8, 9, 9, 9},
        {16, 17, 17, 17},
        {32, 32, 33, 33},
        {80, 80, 80, 81},
        {159, 159, 160, 160}
    },
    {
        {4, 5, 5, 5},
        {8, 9, 9, 9},
        {16, 16, 17, 17},
        {32, 32, 32, 33},
        {78, 79, 79, 79},
        {156, 156, 157, 157}
    },
    {
        {4, 5, 5, 5},
        {8, 8, 9, 9},
        {16, 16, 16, 17},
        {31, 31, 32, 32},
        {77, 77, 78, 78},
        {153, 154, 154, 154}
    },
    {
        {4, 5, 5, 5},
        {8, 8, 9, 9},
        {15, 16, 16, 17},
        {30, 31, 31, 32},
        {75, 76, 76, 77},
        {150, 151, 151, 152}
    },
    {
        {4, 5, 5, 6},
        {8, 8, 9, 9},
        {15, 16, 16, 17},
        {30, 30, 31, 31},
        {74, 74, 75, 75},
        {147, 148, 148, 149}
    },
    {
        {4, 5, 5, 6},
        {8, 8, 9, 9},
        {15, 15, 16, 16},
        {29, 30, 30, 31},
        {72, 73, 73, 74},
        {144, 145, 145, 146}
    },
    {
        {4, 5, 5, 6},
        {8, 8, 9, 9},
        {15, 15, 16, 16},
        {29, 29, 30, 30},
        {71, 71, 72, 73},
        {141, 142, 142, 143}
    },
    {
        {4, 5, 5, 6},
        {7, 8, 9, 9},
        {14, 15, 16, 16},
        {28, 29, 29, 30},
        {69, 70, 71, 71},
        {138, 139, 139, 140}
    },
    {
        {4, 5, 5, 6},
        {7, 8, 9, 9},
        {14, 15, 15, 16},
        {28, 28, 29, 29},
        {68, 69, 69, 70},
        {135, 136, 137, 137}
    },
    {
        {4, 5, 5, 6},
        {7, 8, 9, 9},
        {14, 14, 15, 16},
        {27, 28, 28, 29},
        {66, 67, 68, 68},
        {132, 133, 133, 134}
    },
    {
        {4, 5, 5, 6},
        {7, 8, 8, 9},
        {14, 14, 15, 16},
        {26, 27, 28, 28},
        {65, 66, 66, 67},
        {129, 130, 130, 131}
    },
    {
        {4, 5, 5, 6},
        {7, 8, 8, 9},
        {13, 14, 15, 15},
        {26, 26, 27, 28},
        {63, 64, 65, 65},
        {126, 127, 127, 128}
    },
    {
        {4, 5, 5, 6},
        {7, 8, 8, 9},
        {13, 14, 14, 15},
        {25, 26, 27, 27},
        {62, 63, 63, 64},
        {123, 124, 124, 125}
    },
    {
        {4, 5, 5, 6},
        {7, 8, 8, 9},
        {13, 13, 14, 15},
        {25, 25, 26, 27},
        {60, 61, 62, 63},
        {120, 120, 121, 122}
    },
    {
        {4, 5, 5, 6},
        {7, 7, 8, 9},
        {12, 13, 14, 15},
        {24, 25, 26, 26},
        {59, 59, 60, 61},
        {116, 117, 118, 119}
    },
    {
        {4, 5, 5, 6},
        {6, 7, 8, 9},
        {12, 13, 14, 15},
        {23, 24, 25, 26},
        {57, 58, 59, 60},
        {113, 114, 115, 116}
    },
    {
        {4, 4, 5, 6},
        {6, 7, 8, 9},
        {12, 13, 14, 14},
        {23, 24, 24, 25},
        {55, 56, 57, 58},
        {110, 111, 112, 113}
    },
    {
        {4, 4, 5, 6},
        {6, 7, 8, 9},
        {11, 12, 13, 14},
        {22, 23, 24, 25},
        {54, 55, 56, 57},
        {107, 107, 108, 109}
    },
    {
        {4, 4, 5, 6},
        {6, 7, 8, 9},
        {11, 12, 13, 14},
        {21, 22, 23, 24},
        {52, 53, 54, 55},
        {103, 104, 105, 106}
    },
    {
        {3, 4, 5, 6},
        {6, 7, 8, 9},
        {11, 12, 13, 14},
        {21, 22, 23, 24},
        {50, 51, 52, 53},
        {100, 101, 102, 103}
    },
    {
        {3, 4, 5, 6},
        {6, 7, 8, 9},
        {11, 12, 13, 14},
        {20, 21, 22, 23},
        {49, 50, 51, 52},
        {97, 98, 99, 100}
    },
    {
        {3, 4, 5, 7},
        {6, 7, 8, 9},
        {10, 11, 12, 13},
        {19, 21, 22, 23},
        {47, 48, 49, 50},
        {93, 94, 95, 96}
    },
    {
        {3, 4, 5, 7},
        {6, 7, 8, 9},
        {10, 11, 12, 13},
        {19, 20, 21, 22},
        {45, 46, 48, 49},
        {90, 91, 92, 93}
    },
    {
        {3, 4, 6, 7},
        {5, 7, 8, 9},
        {10, 11, 12, 13},
        {18, 19, 20, 22},
        {44, 45, 46, 47},
        {86, 87, 88, 90}
    },
    {
        {3, 4, 6, 7},
        {5, 6, 8, 9},
        {9, 10, 12, 13},
        {17, 19, 20, 21},
        {42, 43, 44, 45},
        {83, 84, 85, 86}
    },
    {
        {3, 4, 6, 7},
        {5, 6, 7, 9},
        {9, 10, 11, 13},
        {17, 18, 19, 20},
        {40, 41, 43, 44},
        {79, 80, 82, 83}
    },
    {
        {3, 4, 6, 7},
        {5, 6, 7, 9},
        {9, 10, 11, 12},
        {16, 17, 19, 20},
        {38, 40, 41, 42},
        {76, 77, 78, 79}
    },
    {
        {3, 4, 6, 7},
        {5, 6, 7, 9},
        {8, 10, 11, 12},
        {15, 17, 18, 19},
        {37, 38, 39, 40},
        {72, 73, 75, 76}
    },
    {
        {3, 4, 6, 7},
        {5, 6, 7, 9},
        {8, 9, 11, 12},
        {15, 16, 17, 19},
        {35, 36, 37, 39},
        {68, 70, 71, 72}
    }
};
#endif

#ifdef OLD_PAWN
decl_param (PawnPlaceA, 203);
decl_param (PawnPlaceC, -41);
decl_param (PawnPlaceCA, -190);
decl_param (PawnPlaceK, 16);
decl_param (PawnPlaceM, -16);
decl_param (PawnPlaceMA, -154);
decl_param (PawnPlaceMC, -17);
decl_param (PawnPlaceMCA, 692);
#else
decl_3tab(PawnPlace, 566, 4, 6, 72, 3, 3, 3) = {
    {
        {7, 1, -5, -11},
        {26, 14, 2, -10},
        {44, 26, 9, -9},
        {62, 39, 16, -8},
        {81, 52, 22, -7},
        {99, 64, 29, -5}
    },
    {
        {7, 1, -5, -12},
        {25, 14, 2, -10},
        {43, 26, 9, -8},
        {62, 39, 17, -6},
        {80, 52, 24, -4},
        {98, 65, 31, -2}
    },
    {
        {7, 1, -6, -12},
        {25, 14, 2, -9},
        {43, 26, 10, -6},
        {61, 39, 18, -4},
        {79, 52, 26, -1},
        {97, 65, 33, 2}
    },
    {
        {7, 1, -6, -12},
        {25, 14, 3, -8},
        {42, 27, 11, -5},
        {60, 39, 19, -1},
        {78, 52, 27, 2},
        {95, 65, 36, 6}
    },
    {
        {7, 0, -6, -12},
        {24, 13, 3, -8},
        {42, 27, 11, -4},
        {59, 40, 20, 1},
        {77, 53, 29, 5},
        {94, 66, 38, 9}
    },
    {
        {7, 0, -6, -13},
        {24, 13, 3, -7},
        {41, 27, 12, -2},
        {58, 40, 21, 3},
        {76, 53, 30, 8},
        {93, 66, 40, 13}
    },
    {
        {7, 0, -6, -13},
        {24, 13, 3, -7},
        {41, 27, 13, -1},
        {58, 40, 22, 5},
        {75, 53, 32, 11},
        {92, 67, 42, 17}
    },
    {
        {6, 0, -7, -13},
        {23, 13, 4, -6},
        {40, 27, 14, 0},
        {57, 40, 24, 7},
        {74, 54, 34, 14},
        {90, 67, 44, 20}
    },
    {
        {6, 0, -7, -13},
        {23, 13, 4, -6},
        {39, 27, 14, 2},
        {56, 40, 25, 9},
        {73, 54, 35, 17},
        {89, 67, 46, 24}
    },
    {
        {6, 0, -7, -13},
        {23, 13, 4, -5},
        {39, 27, 15, 3},
        {55, 41, 26, 11},
        {72, 54, 37, 19},
        {88, 68, 48, 28}
    },
    {
        {6, -1, -7, -14},
        {22, 13, 4, -5},
        {38, 27, 16, 4},
        {54, 41, 27, 13},
        {70, 54, 38, 22},
        {87, 68, 50, 31}
    },
    {
        {6, -1, -7, -14},
        {22, 13, 5, -4},
        {38, 27, 16, 6},
        {54, 41, 28, 15},
        {69, 55, 40, 25},
        {85, 69, 52, 35}
    },
    {
        {6, -1, -8, -14},
        {21, 13, 5, -4},
        {37, 27, 17, 7},
        {53, 41, 29, 18},
        {68, 55, 42, 28},
        {84, 69, 54, 39}
    },
    {
        {6, -1, -8, -14},
        {21, 13, 5, -3},
        {37, 27, 18, 8},
        {52, 41, 30, 20},
        {67, 55, 43, 31},
        {83, 69, 56, 42}
    },
    {
        {6, -1, -8, -15},
        {21, 13, 5, -3},
        {36, 27, 18, 10},
        {51, 41, 32, 22},
        {66, 56, 45, 34},
        {82, 70, 58, 46}
    },
    {
        {5, -1, -8, -15},
        {20, 13, 6, -2},
        {35, 27, 19, 11},
        {50, 42, 33, 24},
        {65, 56, 46, 37},
        {80, 70, 60, 50}
    },
    {
        {5, -1, -8, -15},
        {20, 13, 6, -1},
        {35, 27, 20, 12},
        {50, 42, 34, 26},
        {64, 56, 48, 40},
        {79, 71, 62, 53}
    },
    {
        {5, -2, -9, -15},
        {20, 13, 6, -1},
        {34, 27, 21, 14},
        {49, 42, 35, 28},
        {63, 56, 50, 43},
        {78, 71, 64, 57}
    },
    {
        {5, -2, -9, -16},
        {19, 13, 6, 0},
        {34, 27, 21, 15},
        {48, 42, 36, 30},
        {62, 57, 51, 46},
        {77, 71, 66, 61}
    },
    {
        {5, -2, -9, -16},
        {19, 13, 7, 0},
        {33, 28, 22, 16},
        {47, 42, 37, 32},
        {61, 57, 53, 48},
        {75, 72, 68, 65}
    },
    {
        {5, -2, -9, -16},
        {19, 13, 7, 1},
        {33, 28, 23, 18},
        {46, 42, 38, 34},
        {60, 57, 54, 51},
        {74, 72, 70, 68}
    },
    {
        {5, -2, -9, -16},
        {18, 13, 7, 1},
        {32, 28, 23, 19},
        {46, 43, 40, 37},
        {59, 58, 56, 54},
        {73, 73, 72, 72}
    },
    {
        {5, -2, -10, -17},
        {18, 13, 7, 2},
        {31, 28, 24, 20},
        {45, 43, 41, 39},
        {58, 58, 58, 57},
        {72, 73, 74, 76}
    },
    {
        {5, -3, -10, -17},
        {18, 13, 8, 2},
        {31, 28, 25, 22},
        {44, 43, 42, 41},
        {57, 58, 59, 60},
        {70, 73, 76, 79}
    },
    {
        {4, -3, -10, -17},
        {17, 13, 8, 3},
        {30, 28, 25, 23},
        {43, 43, 43, 43},
        {56, 59, 61, 63},
        {69, 74, 78, 83}
    },
    {
        {4, -3, -10, -17},
        {17, 13, 8, 3},
        {30, 28, 26, 24},
        {43, 43, 44, 45},
        {55, 59, 62, 66},
        {68, 74, 80, 87}
    },
    {
        {4, -3, -10, -18},
        {17, 12, 8, 4},
        {29, 28, 27, 26},
        {42, 44, 45, 47},
        {54, 59, 64, 69},
        {67, 75, 82, 90}
    },
    {
        {4, -3, -11, -18},
        {16, 12, 9, 5},
        {29, 28, 28, 27},
        {41, 44, 47, 49},
        {53, 59, 66, 72},
        {66, 75, 85, 94}
    },
    {
        {4, -3, -11, -18},
        {16, 12, 9, 5},
        {28, 28, 28, 28},
        {40, 44, 48, 51},
        {52, 60, 67, 75},
        {64, 75, 87, 98}
    },
    {
        {4, -4, -11, -18},
        {16, 12, 9, 6},
        {28, 28, 29, 30},
        {39, 44, 49, 54},
        {51, 60, 69, 77},
        {63, 76, 89, 101}
    },
    {
        {4, -4, -11, -19},
        {15, 12, 9, 6},
        {27, 28, 30, 31},
        {39, 44, 50, 56},
        {50, 60, 70, 80},
        {62, 76, 91, 105}
    },
    {
        {4, -4, -11, -19},
        {15, 12, 9, 7},
        {26, 28, 30, 32},
        {38, 44, 51, 58},
        {49, 61, 72, 83},
        {61, 77, 93, 109}
    },
    {
        {3, -4, -11, -19},
        {15, 12, 10, 7},
        {26, 28, 31, 34},
        {37, 45, 52, 60},
        {48, 61, 73, 86},
        {59, 77, 95, 112}
    },
    {
        {3, -4, -12, -19},
        {14, 12, 10, 8},
        {25, 28, 32, 35},
        {36, 45, 53, 62},
        {47, 61, 75, 89},
        {58, 77, 97, 116}
    },
    {
        {3, -4, -12, -19},
        {14, 12, 10, 8},
        {25, 29, 32, 36},
        {35, 45, 55, 64},
        {46, 61, 77, 92},
        {57, 78, 99, 120}
    },
    {
        {3, -4, -12, -20},
        {14, 12, 10, 9},
        {24, 29, 33, 38},
        {35, 45, 56, 66},
        {45, 62, 78, 95},
        {56, 78, 101, 123}
    },
    {
        {3, -5, -12, -20},
        {13, 12, 11, 9},
        {24, 29, 34, 39},
        {34, 45, 57, 68},
        {44, 62, 80, 98},
        {54, 79, 103, 127}
    },
    {
        {3, -5, -12, -20},
        {13, 12, 11, 10},
        {23, 29, 34, 40},
        {33, 46, 58, 70},
        {43, 62, 81, 101},
        {53, 79, 105, 131}
    },
    {
        {3, -5, -13, -20},
        {13, 12, 11, 11},
        {22, 29, 35, 42},
        {32, 46, 59, 73},
        {42, 63, 83, 104},
        {52, 79, 107, 134}
    },
    {
        {3, -5, -13, -21},
        {12, 12, 11, 11},
        {22, 29, 36, 43},
        {31, 46, 60, 75},
        {41, 63, 85, 106},
        {51, 80, 109, 138}
    },
    {
        {3, -5, -13, -21},
        {12, 12, 12, 12},
        {21, 29, 37, 44},
        {31, 46, 61, 77},
        {40, 63, 86, 109},
        {49, 80, 111, 142}
    },
    {
        {2, -5, -13, -21},
        {12, 12, 12, 12},
        {21, 29, 37, 46},
        {30, 46, 63, 79},
        {39, 63, 88, 112},
        {48, 81, 113, 146}
    },
    {
        {2, -6, -13, -21},
        {11, 12, 12, 13},
        {20, 29, 38, 47},
        {29, 46, 64, 81},
        {38, 64, 89, 115},
        {47, 81, 115, 149}
    },
    {
        {2, -6, -14, -22},
        {11, 12, 12, 13},
        {20, 29, 39, 48},
        {28, 47, 65, 83},
        {37, 64, 91, 118},
        {46, 81, 117, 153}
    },
    {
        {2, -6, -14, -22},
        {11, 12, 13, 14},
        {19, 29, 39, 50},
        {28, 47, 66, 85},
        {36, 64, 93, 121},
        {44, 82, 119, 157}
    },
    {
        {2, -6, -14, -22},
        {10, 12, 13, 14},
        {18, 29, 40, 51},
        {27, 47, 67, 87},
        {35, 65, 94, 124},
        {43, 82, 121, 160}
    },
    {
        {2, -6, -14, -22},
        {10, 12, 13, 15},
        {18, 29, 41, 52},
        {26, 47, 68, 89},
        {34, 65, 96, 127},
        {42, 83, 123, 164}
    },
    {
        {2, -6, -14, -23},
        {10, 12, 13, 15},
        {17, 29, 41, 53},
        {25, 47, 69, 92},
        {33, 65, 97, 130},
        {41, 83, 125, 168}
    },
    {
        {2, -7, -15, -23},
        {9, 11, 14, 16},
        {17, 29, 42, 55},
        {24, 47, 71, 94},
        {32, 65, 99, 132},
        {40, 83, 127, 171}
    },
    {
        {2, -7, -15, -23},
        {9, 11, 14, 17},
        {16, 30, 43, 56},
        {24, 48, 72, 96},
        {31, 66, 101, 135},
        {38, 84, 129, 175}
    },
    {
        {1, -7, -15, -23},
        {9, 11, 14, 17},
        {16, 30, 44, 57},
        {23, 48, 73, 98},
        {30, 66, 102, 138},
        {37, 84, 131, 179}
    },
    {
        {1, -7, -15, -24},
        {8, 11, 14, 18},
        {15, 30, 44, 59},
        {22, 48, 74, 100},
        {29, 66, 104, 141},
        {36, 85, 134, 182}
    },
    {
        {1, -7, -15, -24},
        {8, 11, 15, 18},
        {15, 30, 45, 60},
        {21, 48, 75, 102},
        {28, 67, 105, 144},
        {35, 85, 136, 186}
    },
    {
        {1, -7, -16, -24},
        {8, 11, 15, 19},
        {14, 30, 46, 61},
        {20, 48, 76, 104},
        {27, 67, 107, 147},
        {33, 85, 138, 190}
    },
    {
        {1, -7, -16, -24},
        {7, 11, 15, 19},
        {13, 30, 46, 63},
        {20, 49, 77, 106},
        {26, 67, 109, 150},
        {32, 86, 140, 193}
    },
    {
        {1, -8, -16, -25},
        {7, 11, 15, 20},
        {13, 30, 47, 64},
        {19, 49, 79, 108},
        {25, 67, 110, 153},
        {31, 86, 142, 197}
    },
    {
        {1, -8, -16, -25},
        {6, 11, 16, 20},
        {12, 30, 48, 65},
        {18, 49, 80, 111},
        {24, 68, 112, 156},
        {30, 87, 144, 201}
    },
    {
        {1, -8, -16, -25},
        {6, 11, 16, 21},
        {12, 30, 48, 67},
        {17, 49, 81, 113},
        {23, 68, 113, 159},
        {28, 87, 146, 204}
    },
    {
        {0, -8, -17, -25},
        {6, 11, 16, 21},
        {11, 30, 49, 68},
        {16, 49, 82, 115},
        {22, 68, 115, 161},
        {27, 87, 148, 208}
    },
    {
        {0, -8, -17, -25},
        {5, 11, 16, 22},
        {11, 30, 50, 69},
        {16, 49, 83, 117},
        {21, 69, 116, 164},
        {26, 88, 150, 212}
    },
    {
        {0, -8, -17, -26},
        {5, 11, 17, 23},
        {10, 30, 51, 71},
        {15, 50, 84, 119},
        {20, 69, 118, 167},
        {25, 88, 152, 215}
    },
    {
        {0, -9, -17, -26},
        {5, 11, 17, 23},
        {9, 30, 51, 72},
        {14, 50, 85, 121},
        {19, 69, 120, 170},
        {23, 89, 154, 219}
    },
    {
        {0, -9, -17, -26},
        {4, 11, 17, 24},
        {9, 30, 52, 73},
        {13, 50, 87, 123},
        {18, 69, 121, 173},
        {22, 89, 156, 223}
    },
    {
        {0, -9, -18, -26},
        {4, 11, 17, 24},
        {8, 30, 53, 75},
        {13, 50, 88, 125},
        {17, 70, 123, 176},
        {21, 89, 158, 227}
    },
    {
        {0, -9, -18, -27},
        {4, 11, 18, 25},
        {8, 31, 53, 76},
        {12, 50, 89, 127},
        {16, 70, 124, 179},
        {20, 90, 160, 230}
    },
    {
        {0, -9, -18, -27},
        {3, 11, 18, 25},
        {7, 31, 54, 77},
        {11, 50, 90, 130},
        {15, 70, 126, 182},
        {18, 90, 162, 234}
    },
    {
        {0, -9, -18, -27},
        {3, 11, 18, 26},
        {7, 31, 55, 79},
        {10, 51, 91, 132},
        {14, 71, 128, 185},
        {17, 91, 164, 238}
    },
    {
        {-1, -10, -18, -27},
        {3, 11, 18, 26},
        {6, 31, 55, 80},
        {9, 51, 92, 134},
        {13, 71, 129, 188},
        {16, 91, 166, 241}
    },
    {
        {-1, -10, -19, -28},
        {2, 11, 19, 27},
        {5, 31, 56, 81},
        {9, 51, 93, 136},
        {12, 71, 131, 190},
        {15, 91, 168, 245}
    },
    {
        {-1, -10, -19, -28},
        {2, 10, 19, 27},
        {5, 31, 57, 83},
        {8, 51, 95, 138},
        {11, 72, 132, 193},
        {13, 92, 170, 249}
    },
    {
        {-1, -10, -19, -28},
        {2, 10, 19, 28},
        {4, 31, 57, 84},
        {7, 51, 96, 140},
        {10, 72, 134, 196},
        {12, 92, 172, 252}
    },
    {
        {-1, -10, -19, -28},
        {1, 10, 19, 28},
        {4, 31, 58, 85},
        {6, 52, 97, 142},
        {9, 72, 136, 199},
        {11, 93, 174, 256}
    }
};
#endif

decl_param (PawnValue0, 2208);
decl_param (PawnValue1, -160);
decl_param (QueenCentrality0, 27);
decl_param (QueenCentrality1, 104);
decl_param (QueenCentrality2, -138);
decl_param (QueenTropism0, -9);
decl_param (QueenTropism1, -39);
decl_param (QueenValue, 18432);
decl_param (RookOnSeventh0, -27);
decl_param (RookOnSeventh1, 508);
decl_param (RookOpen0, -57);
decl_param (RookOpen1, 314);
decl_param (RookOpenTrop0, 0);
decl_param (RookOpenTrop1, 152);
decl_param (RookSemi0, 65);
decl_param (RookSemi1, 80);
decl_param (RookSemiTrop0, -3);
decl_param (RookSemiTrop1, 123);
decl_param (RookValue, 10240);
decl_param (SingleIsoClosed0, 109);
decl_param (SingleIsoClosed1, -121);
decl_param (SingleIsoOpen0, 183);
decl_param (SingleIsoOpen1, 1);
decl_param (TripleClosed0, 1280);
decl_param (TripleClosed1, -640);
decl_param (TripleIsoClosed0, 2048);
decl_param (TripleIsoClosed1, -1024);
decl_param (TripleIsoOpen0, 2048);
decl_param (TripleIsoOpen1, -512);
decl_param (TripleOpen0, 1280);
decl_param (TripleOpen1, -480);
decl_param (TwoBishop0, -19);
decl_param (TwoBishop1, 52);

#ifdef FIT_MODE
struct fit_param *All_params[] = {
    &BadBishop0,
    &Backward0,
    &Backward1,
    &BishopBlock0,
    &BishopDefense0,
    &BishopDefense1,
    &BishopPlacement0,
    &BishopPlacement1,
    &BishopPlacement2,
    &BishopValue,
    &BlockedKingShelter0,
    &BlockedKingShelter1,
    &DoubleClosed0,
    &DoubleClosed1,
    &DoubleIsoClosed0,
    &DoubleIsoClosed1,
    &DoubleIsoOpen0,
    &DoubleIsoOpen1,
    &DoubleOpen0,
    &DoubleOpen1,
    &KingCentrality0,
    &KingCentrality1,
    &KingCentrality2,
    &KingShelter0,
    &KingShelter1,
    &KnightCentrality0,
    &KnightCentrality1,
    &KnightCentrality2,
    &KnightDefense0,
    &KnightDefense1,
    &KnightInCorner0,
    &KnightInCorner1,
    &KnightTropism0,
    &KnightTropism1,
    &KnightValue,
    &NoBishopPawn0,
    &NoBishopPawn1,
    &NoKnightPawn0,
    &NoKnightPawn1,
    &NoRookPawn0,
    &NoRookPawn1,
    &OneBishop0,
    &OneBishop1,
#ifdef OLD_PPA
    &PPAdvance0,
    &PPAdvance1,
    &PPAdvance2,
    &PPCentral0,
    &PPCentral1,
#else
    &PPAdvance,
#endif
#ifdef OLD_PAWN
    &PawnPlaceA,
    &PawnPlaceC,
    &PawnPlaceCA,
    &PawnPlaceK,
    &PawnPlaceM,
    &PawnPlaceMA,
    &PawnPlaceMC,
    &PawnPlaceMCA,
#else
    &PawnPlace,
#endif
    &PawnValue0,
    &PawnValue1,
    &QueenCentrality0,
    &QueenCentrality1,
    &QueenCentrality2,
    &QueenTropism0,
    &QueenTropism1,
    &QueenValue,
    &RookOnSeventh0,
    &RookOnSeventh1,
    &RookOpen0,
    &RookOpen1,
    &RookOpenTrop0,
    &RookOpenTrop1,
    &RookSemi0,
    &RookSemi1,
    &RookSemiTrop0,
    &RookSemiTrop1,
    &RookValue,
    &SingleIsoClosed0,
    &SingleIsoClosed1,
    &SingleIsoOpen0,
    &SingleIsoOpen1,
    &TripleClosed0,
    &TripleClosed1,
    &TripleIsoClosed0,
    &TripleIsoClosed1,
    &TripleIsoOpen0,
    &TripleIsoOpen1,
    &TripleOpen0,
    &TripleOpen1,
    &TwoBishop0,
    &TwoBishop1,
    0
};

struct fit_param *pc_params[8] = {	    /* indexed with a pice, used to compensate */
    0,			/* empty */
    &PawnValue0,
    &KnightValue,
    &BishopValue,
    &RookValue,
    &QueenValue,
    0,			/* king :-) */
    0			/* empty */
};


#ifdef OLD_PPA
decl_param (PPAdvanceB, 0);
#endif

struct fit_param *fit_PPA = &PPAdvanceB;    /* constant dump for PPAdvance table */

struct fit_param *fit_PV0 = &PawnValue0,    /* interface for PawnPlace feature */
	         *fit_PV1 = &PawnValue1;

struct state stack[MAXMOVEHISTORY];	    /* dummy, to keep the compiler happy */
int movesmade = 0;

int *fit_castle_st = &stack[2].castle_status;	/* this tells eval the castle status (see king-shelter stuff) */

extern int backup[64];
#endif

